package api

import (
	"github.com/gin-gonic/gin"
	"github.guxuan/haibei/internal/mods/product/biz"
	"github.guxuan/haibei/internal/mods/product/schema"
	"github.guxuan/haibei/pkg/util"
)

// Defining the `ProductCategory` api.
type ProductCategory struct {
	ProductCategoryBIZ *biz.ProductCategory
}

// @Tags 权益产品分类模块
// @Security ApiKeyAuth
// @Summary Query product category list
// @Param current query int true "pagination index" default(1)
// @Param pageSize query int true "pagination size" default(10)
// @Success 200 {object} util.ResponseResult{data=[]schema.ProductCategory}
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/product-categories [get]
func (a *ProductCategory) Query(c *gin.Context) {
	ctx := c.Request.Context()
	var params schema.ProductCategoryQueryParam
	if err := util.ParseQuery(c, &params); err != nil {
		util.ResError(c, err)
		return
	}

	result, err := a.ProductCategoryBIZ.Query(ctx, params)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResPage(c, result.Data, result.PageResult)
}

// @Tags 权益产品分类模块
// @Security ApiKeyAuth
// @Summary Get product category record by ID
// @Param id path string true "unique id"
// @Success 200 {object} util.ResponseResult{data=schema.ProductCategory}
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/product-categories/{id} [get]
func (a *ProductCategory) Get(c *gin.Context) {
	ctx := c.Request.Context()
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	item, err := a.ProductCategoryBIZ.Get(ctx, id)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResSuccess(c, item)
}

// @Tags 权益产品分类模块
// @Security ApiKeyAuth
// @Summary Create product category record
// @Param body body schema.ProductCategoryForm true "Request body"
// @Success 200 {object} util.ResponseResult{data=schema.ProductCategory}
// @Failure 400 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/product-categories [post]
func (a *ProductCategory) Create(c *gin.Context) {
	ctx := c.Request.Context()
	item := new(schema.ProductCategoryForm)
	if err := util.ParseJSON(c, item); err != nil {
		util.ResError(c, err)
		return
	} else if err := item.Validate(); err != nil {
		util.ResError(c, err)
		return
	}

	result, err := a.ProductCategoryBIZ.Create(ctx, item)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResSuccess(c, result)
}

// @Tags 权益产品分类模块
// @Security ApiKeyAuth
// @Summary Update product category record by ID
// @Param id path string true "unique id"
// @Param body body schema.ProductCategoryForm true "Request body"
// @Success 200 {object} util.ResponseResult
// @Failure 400 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/product-categories/{id} [put]
func (a *ProductCategory) Update(c *gin.Context) {
	ctx := c.Request.Context()
	item := new(schema.ProductCategoryForm)
	if err := util.ParseJSON(c, item); err != nil {
		util.ResError(c, err)
		return
	} else if err := item.Validate(); err != nil {
		util.ResError(c, err)
		return
	}
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	err = a.ProductCategoryBIZ.Update(ctx, id, item)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResOK(c)
}

// @Tags 权益产品分类模块
// @Security ApiKeyAuth
// @Summary Delete product category record by ID
// @Param id path string true "unique id"
// @Success 200 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/product-categories/{id} [delete]
func (a *ProductCategory) Delete(c *gin.Context) {
	ctx := c.Request.Context()
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	err = a.ProductCategoryBIZ.Delete(ctx, id)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResOK(c)
}
